test-release.sh 16 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445
  1. #!/bin/bash
  2. # Tested on Linux, MinGW-64
  3. # MinGW's bash 3.1.17 doesn't do ${var^^}
  4. trap 'echo -e "${GREEN}Exiting at user request$RESET"; exit' INT
  5. umask 0022
  6. export MMGEN_TEST_SUITE=1
  7. export MMGEN_NO_LICENSE=1
  8. export PYTHONPATH=.
  9. test_py='test/test.py -n'
  10. objtest_py='test/objtest.py'
  11. unit_tests_py='test/unit_tests.py --names --quiet'
  12. tooltest_py='test/tooltest.py'
  13. tooltest2_py='test/tooltest2.py --names'
  14. gentest_py='test/gentest.py'
  15. scrambletest_py='test/scrambletest.py'
  16. mmgen_tool='cmds/mmgen-tool'
  17. mmgen_keygen='cmds/mmgen-keygen'
  18. python='python3'
  19. rounds=100 rounds_mid=250 rounds_max=500
  20. monero_addrs='3,99,2,22-24,101-104'
  21. dfl_tests='obj unit sha2 alts monero eth autosign btc btc_tn btc_rt bch bch_rt ltc ltc_tn ltc_rt tool tool2 gen'
  22. add_tests='autosign_minimal autosign_live'
  23. PROGNAME=$(basename $0)
  24. while getopts hbCfiIlOpRtvV OPT
  25. do
  26. case "$OPT" in
  27. h) printf " %-16s Test MMGen release\n" "${PROGNAME}:"
  28. echo " USAGE: $PROGNAME [options] [branch] [tests]"
  29. echo " OPTIONS: '-h' Print this help message"
  30. echo " '-b' Buffer keypresses for all invocations of 'test/test.py'"
  31. echo " '-C' Run tests in coverage mode"
  32. echo " '-f' Speed up the tests by using fewer rounds"
  33. echo " '-i' Create and install Python package, then run tests"
  34. echo " '-I' Install the package only; don't run tests"
  35. echo " '-l' List the test name symbols"
  36. echo " '-O' Use pexpect.spawn rather than popen_spawn for applicable tests"
  37. echo " '-p' Pause between tests"
  38. echo " '-R' Don't remove temporary files after program has exited"
  39. echo " '-t' Print the tests without running them"
  40. echo " '-v' Run test/test.py with '--exact-output' and other commands with '--verbose' switch"
  41. echo " '-V' Run test/test.py and other commands with '--verbose' switch"
  42. echo " AVAILABLE TESTS:"
  43. echo " obj - data objects"
  44. echo " unit - unit tests"
  45. echo " sha2 - MMGen sha2 implementation"
  46. echo " alts - operations for all supported gen-only altcoins"
  47. echo " monero - operations for Monero"
  48. echo " eth - operations for Ethereum"
  49. echo " autosign - autosign"
  50. echo " btc - bitcoin"
  51. echo " btc_tn - bitcoin testnet"
  52. echo " btc_rt - bitcoin regtest"
  53. echo " bch - bitcoin cash (BCH)"
  54. echo " bch_rt - bitcoin cash (BCH) regtest"
  55. echo " ltc - litecoin"
  56. echo " ltc_tn - litecoin testnet"
  57. echo " ltc_rt - litecoin regtest"
  58. echo " tool - tooltest (all supported coins)"
  59. echo " tool2 - tooltest2 (all supported coins)"
  60. echo " gen - gentest (all supported coins)"
  61. echo " By default, all tests are run"
  62. exit ;;
  63. b) test_py+=" --buf-keypress" ;;
  64. C) mkdir -p 'test/trace'
  65. touch 'test/trace.acc'
  66. test_py+=" --coverage"
  67. tooltest_py+=" --coverage"
  68. tooltest2_py+=" --fork --coverage"
  69. scrambletest_py+=" --coverage"
  70. python="python3 -m trace --count --file=test/trace.acc --coverdir=test/trace"
  71. unit_tests_py="$python $unit_tests_py"
  72. objtest_py="$python $objtest_py"
  73. gentest_py="$python $gentest_py"
  74. mmgen_tool="$python $mmgen_tool"
  75. mmgen_keygen="$python $mmgen_keygen" ;&
  76. f) rounds=10 rounds_mid=25 rounds_max=50 monero_addrs='3,23' ;;
  77. i) INSTALL=1 ;;
  78. I) INSTALL_ONLY=1 ;;
  79. l) echo -e "Default tests:\n $dfl_tests"
  80. echo -e "Additional tests:\n $add_tests"
  81. exit ;;
  82. O) test_py+=" --pexpect-spawn" ;;
  83. p) PAUSE=1 ;;
  84. R) NO_TMPFILE_REMOVAL=1 ;;
  85. t) TESTING=1 ;;
  86. v) EXACT_OUTPUT=1 test_py+=" --exact-output" ;&
  87. V) VERBOSE=1 [ "$EXACT_OUTPUT" ] || test_py+=" --verbose"
  88. tooltest_py+=" --verbose" tooltest2_py+=" --verbose"
  89. gentest_py+=" --verbose" mmgen_tool+=" --verbose"
  90. unit_tests_py="${unit_tests_py/--quiet/--verbose}"
  91. scrambletest_py+=" --verbose" ;;
  92. *) exit ;;
  93. esac
  94. done
  95. [ "$EXACT_OUTPUT" -o "$VERBOSE" ] || objtest_py+=" -S"
  96. shift $((OPTIND-1))
  97. REFDIR='test/ref'
  98. if uname -a | grep -qi mingw; then SUDO='' MINGW=1; else SUDO='sudo' MINGW=''; fi
  99. [ "$MINGW" ] || RED="\e[31;1m" GREEN="\e[32;1m" YELLOW="\e[33;1m" RESET="\e[0m"
  100. [ "$INSTALL" ] && {
  101. BRANCH=$1; shift
  102. BRANCHES=$(git branch)
  103. FOUND_BRANCH=$(for b in ${BRANCHES/\*}; do [ "$b" == "$BRANCH" ] && echo ok; done)
  104. [ "$FOUND_BRANCH" ] || { echo "Branch '$BRANCH' not found!"; exit; }
  105. }
  106. set -e
  107. check() {
  108. [ "$BRANCH" ] || { echo 'No branch specified. Exiting'; exit; }
  109. [ "$(git diff $BRANCH)" == "" ] || {
  110. echo "Unmerged changes from branch '$BRANCH'. Exiting"
  111. exit
  112. }
  113. git diff $BRANCH >/dev/null 2>&1 || exit
  114. }
  115. uninstall() {
  116. set +e
  117. eval "$SUDO ./scripts/uninstall-mmgen.py"
  118. [ "$?" -ne 0 ] && { echo 'Uninstall failed, but proceeding anyway'; sleep 1; }
  119. set -e
  120. }
  121. install() {
  122. set -x
  123. eval "$SUDO rm -rf .test-release"
  124. git clone --branch $BRANCH --single-branch . .test-release
  125. (
  126. cd .test-release
  127. ./setup.py sdist
  128. mkdir pydist && cd pydist
  129. if [ "$MINGW" ]; then unzip ../dist/mmgen-*.zip; else tar zxvf ../dist/mmgen-*gz; fi
  130. cd mmgen-*
  131. eval "$SUDO ./setup.py clean --all"
  132. [ "$MINGW" ] && ./setup.py build --compiler=mingw32
  133. eval "$SUDO ./setup.py install --force"
  134. )
  135. set +x
  136. }
  137. do_test() {
  138. set +x
  139. for i in "$@"; do
  140. echo -e "${GREEN}Running:$RESET $YELLOW$i$RESET"
  141. [ "$TESTING" ] || eval "$i" || {
  142. echo -e $RED"Test '$CUR_TEST' failed at command '$i'"$RESET
  143. exit
  144. }
  145. done
  146. }
  147. i_obj='Data object'
  148. s_obj='Testing data objects'
  149. t_obj=(
  150. "$objtest_py --coin=btc"
  151. "$objtest_py --coin=btc --testnet=1"
  152. "$objtest_py --coin=ltc"
  153. "$objtest_py --coin=ltc --testnet=1")
  154. f_obj='Data object test complete'
  155. i_unit='Unit tests'
  156. s_unit='Running unit'
  157. t_unit=("$unit_tests_py")
  158. f_unit='Unit tests run complete'
  159. i_sha2='MMGen SHA2 implementation'
  160. s_sha2='Testing SHA2 implementation'
  161. t_sha2=(
  162. "$python test/sha2test.py sha256 $rounds_max"
  163. "$python test/sha2test.py sha512 $rounds_max")
  164. f_sha2='SHA2 test complete'
  165. i_alts='Gen-only altcoin'
  166. s_alts='The following tests will test generation operations for all supported altcoins'
  167. t_alts=(
  168. "$scrambletest_py"
  169. "$test_py ref_altcoin"
  170. "$gentest_py --coin=btc 2 $rounds"
  171. "$gentest_py --coin=btc --type=compressed 2 $rounds"
  172. "$gentest_py --coin=btc --type=segwit 2 $rounds"
  173. "$gentest_py --coin=btc --type=bech32 2 $rounds"
  174. "$gentest_py --coin=ltc 2 $rounds"
  175. "$gentest_py --coin=ltc --type=compressed 2 $rounds"
  176. "$gentest_py --coin=ltc --type=segwit 2 $rounds"
  177. "$gentest_py --coin=ltc --type=bech32 2 $rounds"
  178. "$gentest_py --coin=etc 2 $rounds"
  179. "$gentest_py --coin=eth 2 $rounds"
  180. "$gentest_py --coin=zec 2 $rounds"
  181. "$gentest_py --coin=zec --type=zcash_z 2 $rounds_mid"
  182. "$gentest_py --coin=btc 2:ext $rounds"
  183. "$gentest_py --coin=btc --type=compressed 2:ext $rounds"
  184. "$gentest_py --coin=btc --type=segwit 2:ext $rounds"
  185. "$gentest_py --coin=ltc 2:ext $rounds"
  186. "$gentest_py --coin=ltc --type=compressed 2:ext $rounds"
  187. # "$gentest_py --coin=ltc --type=segwit 2:ext $rounds" # pycoin generates old-style LTC Segwit addrs
  188. "$gentest_py --coin=etc 2:ext $rounds"
  189. "$gentest_py --coin=eth 2:ext $rounds"
  190. "$gentest_py --coin=zec 2:ext $rounds"
  191. "$gentest_py --coin=zec --type=zcash_z 2:ext $rounds_mid"
  192. "$gentest_py --all 2:pycoin $rounds"
  193. "$gentest_py --all 2:pyethereum $rounds"
  194. "$gentest_py --all 2:keyconv $rounds_mid"
  195. "$gentest_py --all 2:zcash_mini $rounds_mid")
  196. if [ "$MINGW" ]; then
  197. t_alts[13]="# MSWin platform: skipping zcash z-addr generation and altcoin verification with third-party tools"
  198. i=14 end=${#t_alts[*]}
  199. while [ $i -lt $end ]; do unset t_alts[$i]; let i++; done
  200. fi
  201. f_alts='Gen-only altcoin tests completed'
  202. if [ "$MINGW" ]; then
  203. TMPDIR='/tmp/mmgen-test-release'
  204. else
  205. TMPDIR='/tmp/mmgen-test-release-'$(cat /dev/urandom | base32 - | head -n1 | cut -b 1-16)
  206. fi
  207. mkdir -p $TMPDIR
  208. i_monero='Monero'
  209. s_monero='Testing key-address file generation and wallet creation and sync operations for Monero'
  210. s_monero='The monerod (mainnet) daemon must be running for the following tests'
  211. t_monero=(
  212. "mmgen-walletgen -q -r0 -p1 -Llabel --outdir $TMPDIR -o words"
  213. "$mmgen_keygen -q --accept-defaults --outdir $TMPDIR --coin=xmr $TMPDIR/*.mmwords $monero_addrs"
  214. 'cs1=$(mmgen-tool -q --accept-defaults --coin=xmr keyaddrfile_chksum $TMPDIR/*-XMR*.akeys)'
  215. "$mmgen_keygen -q --use-old-ed25519 --accept-defaults --outdir $TMPDIR --coin=xmr $TMPDIR/*.mmwords $monero_addrs"
  216. 'cs2=$(mmgen-tool -q --accept-defaults --coin=xmr keyaddrfile_chksum $TMPDIR/*-XMR*.akeys)'
  217. '[ "$cs1" == "$cs2" ] || false'
  218. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR keyaddrlist2monerowallets $TMPDIR/*-XMR*.akeys addrs=23"
  219. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR keyaddrlist2monerowallets $TMPDIR/*-XMR*.akeys addrs=103-200"
  220. 'rm $TMPDIR/*-MoneroWallet*'
  221. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR keyaddrlist2monerowallets $TMPDIR/*-XMR*.akeys"
  222. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR syncmonerowallets $TMPDIR/*-XMR*.akeys addrs=3"
  223. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR syncmonerowallets $TMPDIR/*-XMR*.akeys addrs=23-29"
  224. "$mmgen_tool -q --accept-defaults --outdir $TMPDIR syncmonerowallets $TMPDIR/*-XMR*.akeys"
  225. )
  226. [ "$MINGW" ] && {
  227. t_monero[2]="# MSWin platform: skipping Monero wallet creation and sync tests; NOT verifying key-addr list"
  228. i=3 end=${#t_monero[*]}
  229. while [ $i -lt $end ]; do unset t_monero[$i]; let i++; done
  230. }
  231. [ "$monero_addrs" == '3,23' ] && {
  232. unset t_monero[12]
  233. unset t_monero[7]
  234. unset t_monero[3]
  235. }
  236. f_monero='Monero tests completed'
  237. i_eth='Ethereum'
  238. s_eth='Testing transaction and tracking wallet operations for Ethereum and Ethereum Classic'
  239. t_eth=(
  240. "$test_py --coin=eth ethdev"
  241. "$test_py --coin=etc ethdev"
  242. )
  243. f_eth='Ethereum tests completed'
  244. i_autosign='Autosign'
  245. s_autosign='The bitcoin, bitcoin-abc and litecoin mainnet and testnet daemons must be running for the following test'
  246. t_autosign=("$test_py autosign")
  247. f_autosign='Autosign test complete'
  248. i_autosign_minimal='Autosign Minimal'
  249. s_autosign_minimal='The bitcoin mainnet and testnet daemons must be running for the following test'
  250. t_autosign_minimal=("$test_py autosign_minimal")
  251. f_autosign_minimal='Autosign Minimal test complete'
  252. i_autosign_live='Autosign Live'
  253. s_autosign_live="The bitcoin mainnet and testnet daemons must be running for the following test\n"
  254. s_autosign_live+="${YELLOW}Mountpoint, '/etc/fstab' and removable device must be configured "
  255. s_autosign_live+="as described in 'mmgen-autosign --help'${RESET}"
  256. t_autosign_live=("$test_py autosign_live")
  257. f_autosign_live='Autosign Live test complete'
  258. i_btc='Bitcoin mainnet'
  259. s_btc='The bitcoin (mainnet) daemon must both be running for the following tests'
  260. t_btc=(
  261. "$test_py --exclude regtest"
  262. "$test_py --segwit"
  263. "$test_py --segwit-random"
  264. "$test_py --bech32"
  265. "$python scripts/compute-file-chksum.py $REFDIR/*testnet.rawtx >/dev/null 2>&1")
  266. f_btc='You may stop the bitcoin (mainnet) daemon if you wish'
  267. i_btc_tn='Bitcoin testnet'
  268. s_btc_tn='The bitcoin testnet daemon must both be running for the following tests'
  269. t_btc_tn=(
  270. "$test_py --testnet=1"
  271. "$test_py --testnet=1 --segwit"
  272. "$test_py --testnet=1 --segwit-random"
  273. "$test_py --testnet=1 --bech32")
  274. f_btc_tn='You may stop the bitcoin testnet daemon if you wish'
  275. i_btc_rt='Bitcoin regtest'
  276. s_btc_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  277. t_btc_rt=(
  278. "$test_py regtest"
  279. )
  280. f_btc_rt='Regtest (Bob and Alice) mode tests for BTC completed'
  281. i_bch='Bitcoin cash (BCH)'
  282. s_bch='The bitcoin cash daemon (Bitcoin ABC) must both be running for the following tests'
  283. t_bch=("$test_py --coin=bch --exclude regtest")
  284. f_bch='You may stop the Bitcoin ABC daemon if you wish'
  285. i_bch_rt='Bitcoin cash (BCH) regtest'
  286. s_bch_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  287. t_bch_rt=("$test_py --coin=bch regtest")
  288. f_bch_rt='Regtest (Bob and Alice) mode tests for BCH completed'
  289. i_ltc='Litecoin'
  290. s_ltc='The litecoin daemon must both be running for the following tests'
  291. t_ltc=(
  292. "$test_py --coin=ltc --exclude regtest"
  293. "$test_py --coin=ltc --segwit"
  294. "$test_py --coin=ltc --segwit-random"
  295. "$test_py --coin=ltc --bech32")
  296. f_ltc='You may stop the litecoin daemon if you wish'
  297. i_ltc_tn='Litecoin testnet'
  298. s_ltc_tn='The litecoin testnet daemon must both be running for the following tests'
  299. t_ltc_tn=(
  300. "$test_py --coin=ltc --testnet=1 --exclude regtest"
  301. "$test_py --coin=ltc --testnet=1 --segwit"
  302. "$test_py --coin=ltc --testnet=1 --segwit-random"
  303. "$test_py --coin=ltc --testnet=1 --bech32")
  304. f_ltc_tn='You may stop the litecoin testnet daemon if you wish'
  305. i_ltc_rt='Litecoin regtest'
  306. s_ltc_rt="The following tests will test MMGen's regtest (Bob and Alice) mode"
  307. t_ltc_rt=("$test_py --coin=ltc regtest")
  308. f_ltc_rt='Regtest (Bob and Alice) mode tests for LTC completed'
  309. i_tool2='Tooltest2'
  310. s_tool2="The following tests will run '$tooltest2_py' for all supported coins"
  311. t_tool2=(
  312. "$tooltest2_py --quiet"
  313. "$tooltest2_py --quiet --coin=btc"
  314. "$tooltest2_py --quiet --coin=btc --testnet=1"
  315. "$tooltest2_py --quiet --coin=ltc"
  316. "$tooltest2_py --quiet --coin=ltc --testnet=1"
  317. "$tooltest2_py --quiet --coin=bch"
  318. "$tooltest2_py --quiet --coin=bch --testnet=1"
  319. "$tooltest2_py --quiet --coin=zec"
  320. "$tooltest2_py --quiet --coin=zec --type=zcash_z"
  321. "$tooltest2_py --quiet --coin=xmr"
  322. "$tooltest2_py --quiet --coin=dash"
  323. "$tooltest2_py --quiet --coin=eth"
  324. "$tooltest2_py --quiet --coin=eth --testnet=1"
  325. "$tooltest2_py --quiet --coin=eth --token=mm1"
  326. "$tooltest2_py --quiet --coin=eth --token=mm1 --testnet=1"
  327. "$tooltest2_py --quiet --coin=etc")
  328. f_tool2='tooltest2 tests completed'
  329. i_tool='Tooltest'
  330. s_tool="The following tests will run '$tooltest_py' for all supported coins"
  331. t_tool=(
  332. "$tooltest_py --coin=btc cryptocoin"
  333. "$tooltest_py --coin=btc mnemonic"
  334. "$tooltest_py --coin=ltc cryptocoin"
  335. "$tooltest_py --coin=eth cryptocoin"
  336. "$tooltest_py --coin=etc cryptocoin"
  337. "$tooltest_py --coin=dash cryptocoin"
  338. "$tooltest_py --coin=doge cryptocoin"
  339. "$tooltest_py --coin=emc cryptocoin"
  340. "$tooltest_py --coin=zec cryptocoin")
  341. [ "$MINGW" ] || {
  342. t_tool_len=${#t_tool[*]}
  343. t_tool[$t_tool_len]="$tooltest_py --coin=zec --type=zcash_z cryptocoin"
  344. }
  345. f_tool='tooltest tests completed'
  346. i_gen='Gentest'
  347. s_gen="The following tests will run '$gentest_py' on mainnet and testnet for all supported coins"
  348. t_gen=(
  349. "$gentest_py -q 2 $REFDIR/btcwallet.dump"
  350. "$gentest_py -q --type=segwit 2 $REFDIR/btcwallet-segwit.dump"
  351. "$gentest_py -q --type=bech32 2 $REFDIR/btcwallet-bech32.dump"
  352. "$gentest_py -q 1:2 $rounds"
  353. "$gentest_py -q --type=segwit 1:2 $rounds"
  354. "$gentest_py -q --type=bech32 1:2 $rounds"
  355. "$gentest_py -q --testnet=1 2 $REFDIR/btcwallet-testnet.dump"
  356. "$gentest_py -q --testnet=1 1:2 $rounds"
  357. "$gentest_py -q --testnet=1 --type=segwit 1:2 $rounds"
  358. "$gentest_py -q --coin=ltc 2 $REFDIR/litecoin/ltcwallet.dump"
  359. "$gentest_py -q --coin=ltc --type=segwit 2 $REFDIR/litecoin/ltcwallet-segwit.dump"
  360. "$gentest_py -q --coin=ltc --type=bech32 2 $REFDIR/litecoin/ltcwallet-bech32.dump"
  361. "$gentest_py -q --coin=ltc 1:2 $rounds"
  362. "$gentest_py -q --coin=ltc --type=segwit 1:2 $rounds"
  363. "$gentest_py -q --coin=ltc --testnet=1 2 $REFDIR/litecoin/ltcwallet-testnet.dump"
  364. "$gentest_py -q --coin=ltc --testnet=1 1:2 $rounds"
  365. "$gentest_py -q --coin=ltc --testnet=1 --type=segwit 1:2 $rounds")
  366. f_gen='gentest tests completed'
  367. [ -d .git -a -n "$INSTALL" -a -z "$TESTING" ] && {
  368. check
  369. uninstall
  370. install
  371. cd .test-release/pydist/mmgen-*
  372. }
  373. [ "$INSTALL_ONLY" ] && exit
  374. prompt_skip() {
  375. echo -n "Enter 's' to skip, or ENTER to continue: "; read -n1; echo
  376. [ "$REPLY" == 's' ] && return 0
  377. return 1
  378. }
  379. run_tests() {
  380. for t in $1; do
  381. eval echo -e "'\n'"\${GREEN}'###' Running $(echo \$i_$t) tests\$RESET
  382. eval echo -e $(echo \$s_$t)
  383. [ "$PAUSE" ] && prompt_skip && continue
  384. CUR_TEST=$t
  385. eval "do_test \"\${t_$t[@]}\""
  386. eval echo -e \$GREEN$(echo \$f_$t)\$RESET
  387. done
  388. }
  389. check_args() {
  390. for i in $tests; do
  391. echo "$dfl_tests $add_tests" | grep -q "\<$i\>" || { echo "$i: unrecognized argument"; exit; }
  392. done
  393. }
  394. tests=$dfl_tests
  395. [ "$*" ] && tests="$*"
  396. check_args
  397. echo "Running tests: $tests"
  398. START=$(date +%s)
  399. run_tests "$tests"
  400. TIME=$(($(date +%s)-START))
  401. MS=$(printf %02d:%02d $((TIME/60)) $((TIME%60)))
  402. [ "$NO_TMPFILE_REMOVAL" ] || rm -rf /tmp/mmgen-test-release-*
  403. echo -e "${GREEN}All OK. Total elapsed time: $MS$RESET"